Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!

Bug 803485

Summary: sys-apps/texinfo-6.8 fails to build with glibc-2.34
Product: Gentoo Linux Reporter: Andreas K. Hüttel <dilfridge>
Component: Current packagesAssignee: Gentoo's Team for Core System packages <base-system>
Status: RESOLVED FIXED    
Severity: normal CC: perl
Priority: Normal Keywords: PATCH
Version: unspecified   
Hardware: All   
OS: Linux   
URL: https://lists.gnu.org/archive/html/bug-texinfo/2021-07/msg00035.html
Whiteboard:
Package list:
Runtime testing required: ---
Bug Depends on:    
Bug Blocks: 803482    
Attachments: build.log
build.log

Description Andreas K. Hüttel archtester gentoo-dev 2021-07-23 07:59:35 UTC
(chroot is using master glibc 10 days before release of 2.34)

x86_64-pc-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I../..     -march=native -O2 -pipe -ggdb -frecord-gcc-switches -flto -c -o mbrtowc.o mbrtowc.c
x86_64-pc-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I../..     -march=native -O2 -pipe -ggdb -frecord-gcc-switches -flto -c -o regex.o regex.c
x86_64-pc-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I../..     -march=native -O2 -pipe -ggdb -frecord-gcc-switches -flto -c -o malloc/dynarray_at_failure.o malloc/dynarray_at_failure.c
x86_64-pc-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I../..     -march=native -O2 -pipe -ggdb -frecord-gcc-switches -flto -c -o malloc/dynarray_emplace_enlarge.o malloc/dynarray_emplace_enlarge.c
x86_64-pc-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I../..     -march=native -O2 -pipe -ggdb -frecord-gcc-switches -flto -c -o malloc/dynarray_finalize.o malloc/dynarray_finalize.c
x86_64-pc-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I../..     -march=native -O2 -pipe -ggdb -frecord-gcc-switches -flto -c -o malloc/dynarray_resize.o malloc/dynarray_resize.c
x86_64-pc-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I../..     -march=native -O2 -pipe -ggdb -frecord-gcc-switches -flto -c -o malloc/dynarray_resize_clear.o malloc/dynarray_resize_clear.c
x86_64-pc-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I../..     -march=native -O2 -pipe -ggdb -frecord-gcc-switches -flto -c -o glthread/lock.o glthread/lock.c
x86_64-pc-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I../..     -march=native -O2 -pipe -ggdb -frecord-gcc-switches -flto -c -o uniwidth/width.o uniwidth/width.c
In file included from regexec.c:1368,
                 from regex.c:74:
./malloc/dynarray-skeleton.c:195:24: error: expected declaration specifiers or <E2><80><98>...<E2><80><99> before <E2><80><98>(<E2><80><99> token
  195 | __attribute_nonnull__ ((1))
      |                        ^
./malloc/dynarray-skeleton.c:205:51: error: expected declaration specifiers or <E2><80><98>...<E2><80><99> before <E2><80><98>(<E2><80><99> token
  205 | __attribute_maybe_unused__ __attribute_nonnull__ ((1))
      |                                                   ^
./malloc/dynarray-skeleton.c:216:24: error: expected declaration specifiers or <E2><80><98>...<E2><80><99> before <E2><80><98>(<E2><80><99> token
  216 | __attribute_nonnull__ ((1))
      |                        ^
./malloc/dynarray-skeleton.c:225:24: error: expected declaration specifiers or <E2><80><98>...<E2><80><99> before <E2><80><98>(<E2><80><99> token
  225 | __attribute_nonnull__ ((1))
      |                        ^
Comment 1 Sam James archtester gentoo-dev Security 2021-07-24 01:15:14 UTC Comment hidden (obsolete)
Comment 2 Sam James archtester gentoo-dev Security 2021-07-24 01:16:08 UTC
Created attachment 726271 [details]
build.log

Portage 3.0.20 (python 3.9.6-final-0, default/linux/amd64/17.1/systemd, gcc-11.1.0, glibc-9999, 5.10.51-gentoo-dist-hardened x86_64)
=================================================================
System uname: Linux-5.10.51-gentoo-dist-hardened-x86_64-AMD_Ryzen_7_2700_Eight-Core_Processor-with-glibc2.33.9000
KiB Mem:    16365968 total,   6390512 free
KiB Swap:   16777212 total,  16329468 free
Timestamp of repository gentoo: Fri, 23 Jul 2021 00:45:01 +0000
Head commit of repository gentoo: ac72791ea1b6abaef11b0ddb83185879e8550e5f
sh bash 5.1_p8
ld GNU ld (Gentoo 2.36.1 p3) 2.36.1
app-shells/bash:          5.1_p8::gentoo
dev-lang/perl:            5.34.0-r1::gentoo
dev-lang/python:          3.9.6::gentoo, 3.10.0_beta4::gentoo
dev-util/cmake:           3.21.0::gentoo
sys-apps/baselayout:      2.7-r3::gentoo
sys-apps/sandbox:         2.24::gentoo
sys-devel/autoconf:       2.69-r5::gentoo
sys-devel/automake:       1.16.3-r1::gentoo
sys-devel/binutils:       2.36.1-r1::gentoo
sys-devel/gcc:            11.1.0-r2::gentoo
sys-devel/gcc-config:     2.4::gentoo
sys-devel/libtool:        2.4.6-r6::gentoo
sys-devel/make:           4.3::gentoo
sys-kernel/linux-headers: 5.13::gentoo (virtual/os-headers)
sys-libs/glibc:           9999::gentoo
Repositories:

gentoo
    location: /var/db/repos/gentoo
    sync-type: rsync
    sync-uri: rsync://rsync.gentoo.org/gentoo-portage
    priority: -1000
    sync-rsync-verify-metamanifest: yes
    sync-rsync-extra-opts:
    sync-rsync-verify-jobs: 1
    sync-rsync-verify-max-age: 24

ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="@FREE"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -pipe -march=native -fdiagnostics-color=always -frecord-gcc-switches"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/gconf /etc/gentoo-release /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-O2 -pipe -march=native -fdiagnostics-color=always -frecord-gcc-switches"
DISTDIR="/var/cache/distfiles"
EMERGE_DEFAULT_OPTS="--keep-going=y --with-bdeps=y --deep --complete-graph --usepkg=y"
ENV_UNSET="CARGO_HOME DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN GOPATH PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS="-O2 -pipe -march=native -fdiagnostics-color=always -frecord-gcc-switches"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs buildpkg config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox multilib-strict news parallel-fetch parallel-install pid-sandbox preserve-libs protect-owned qa-unresolved-soname-deps sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe -march=native -fdiagnostics-color=always -frecord-gcc-switches"
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="C.UTF8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed -Wl,--defsym=__gentoo_check_ldflags__=0"
PKGDIR="/var/cache/binpkgs"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="acl amd64 bzip2 cli crypt dri fortran gdbm iconv ipv6 libglvnd libtirpc multilib ncurses nls nptl openmp pam pcre readline seccomp split-usr ssl systemd tcpd udev unicode xattr zlib" ABI_X86="64" ADA_TARGET="gnat_2018" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="mmx mmxext sse sse2" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock greis isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="libinput" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LUA_SINGLE_TARGET="lua5-1" LUA_TARGETS="lua5-1" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php7-3 php7-4" POSTGRES_TARGETS="postgres10 postgres11" PYTHON_SINGLE_TARGET="python3_9" PYTHON_TARGETS="python3_9" RUBY_TARGETS="ruby26" USERLAND="GNU" VIDEO_CARDS="amdgpu fbdev intel nouveau radeon radeonsi vesa dummy v4l" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq proto steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LC_ALL, LINGUAS, MAKEOPTS, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, RUSTFLAGS
Comment 3 Sam James archtester gentoo-dev Security 2021-07-24 02:46:05 UTC
Another gnulib issue, this time it's conflicting macros.

Reported upstream: https://lists.gnu.org/archive/html/bug-texinfo/2021-07/msg00035.html.
Comment 4 Sam James archtester gentoo-dev Security 2021-08-06 12:21:12 UTC
We have two options given that updating gnulib entirely is a bit messy:
1. Fedora's patch (https://src.fedoraproject.org/rpms/texinfo/blob/rawhide/f/texinfo-6.8-undo-gnulib-nonnul.patch)
2. Exherbo's (from upstream, kind of) (https://git.exherbo.org/arbor.git/commit/?id=ced5f5cd0373d86f350f6d21e341cebcacf589b1)
Comment 5 Larry the Git Cow gentoo-dev 2021-09-09 19:24:09 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=a3af03bb17aa0f106c97032355aa2c7e63f58b02

commit a3af03bb17aa0f106c97032355aa2c7e63f58b02
Author:     Andreas K. Hüttel <dilfridge@gentoo.org>
AuthorDate: 2021-09-09 19:23:28 +0000
Commit:     Andreas K. Hüttel <dilfridge@gentoo.org>
CommitDate: 2021-09-09 19:23:57 +0000

    sys-apps/texinfo: Fix build with glibc-2.34 (using RH patch)
    
    Closes: https://bugs.gentoo.org/803485
    Package-Manager: Portage-3.0.20, Repoman-3.0.3
    Signed-off-by: Andreas K. Huettel <dilfridge@gentoo.org>

 .../files/texinfo-6.8-undo-gnulib-nonnul.patch     | 186 +++++++++++++++++++++
 sys-apps/texinfo/texinfo-6.8.ebuild                |   4 +
 2 files changed, 190 insertions(+)